/*************************************************************************
	-----------------------------------------------------
           		Copyright 2002, 
	   University of Massachusetts, Amherst. 
	-----------------------------------------------------

This package was created at the University of Massachusetts, Amherst. 
The University of Massachusetts makes no warranty about the suitability 
of this software for any purpose. It is presented on an "as is" basis.

CONDITIONS:

The use of software for commercial purposes is strictly forbidden
without a written consent from its authors or the University of 
Massachusetts, Amherst.

**************************************************************************/
/**CHeaderFile*****************************************************************

  FileName    [dummy.h]

  PackageName [BDS]

  Synopsis    [BDD decomposition-based logic optimization program]

  Description []

  SeeAlso     []

  Author      [Congguang Yang]

  Last date   [3/27/99]

******************************************************************************/

#ifndef _DUMMYBDD
#define _DUMMYBDD

/*---------------------------------------------------------------------------*/
/* Nested includes                                                           */
/*---------------------------------------------------------------------------*/

#include "lopt.h"
#include "cuddInt.h"
#include "bnet.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/

#define BDDPOOL_LOCAL_ONE  0xFFFF
#define BDDPOOL_LOCAL_ZERO 0xFFFE

/*---------------------------------------------------------------------------*/
/* Stucture declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN DdNode * BDS_BuildDummyLocalBdd ARGS((DdManager*,SopPool*,BnetNode*,int**,int,bdsOptions*));
EXTERN SopPool * BDS_DumpSopLocal ARGS((DdManager*,DdNode*));
EXTERN int bdsConvertDummy2Real ARGS((FactorTreeNode*,int*,bdsOptions*));
EXTERN DdNode * BDS_BuildDDFromSopLocal ARGS((DdManager*,SopPool*,int*,bdsOptions*));
EXTERN bddPool * BDS_StoreBddPoolLocal ARGS((DdManager*,DdNode*));
EXTERN DdNode * BDS_BuildDDFromBddPoolLocal ARGS((DdManager*,bddPool*,int**,int,bdsOptions*));
EXTERN DdNode * bdsBuildDDFromBddPoolLocalWithOutCreateDummy ARGS((DdManager*,bddPool*,int*));
EXTERN DdNode * BDS_BuildDDFromBddPoolLocalRecursive ARGS((DdManager*,bddNode*,int,int*));
EXTERN void bdsFreeBddPoolLocal ARGS((DdManager*,bddPool*));


#endif /* _DUMMYBDD */



